export declare const AWS_ENV_REGEX: RegExp;
export declare enum ArtifactType {
    AwsCloudFormationStack = "aws:cloudformation:stack",
    AwsEcrDockerImage = "aws:ecr:image",
    AwsS3Object = "aws:s3:object"
}
export interface Artifact {
    readonly type: ArtifactType;
    readonly environment: string;
    readonly metadata?: {
        [path: string]: any;
    };
    readonly dependencies?: string[];
    readonly missing?: {
        [key: string]: any;
    };
    readonly properties?: {
        [name: string]: any;
    };
    readonly autoDeploy?: boolean;
}
export declare function validateArtifact(artifcat: Artifact): void;
